clear; 
clc;
close all; % 
%==========================================================================
 K                                =1024*2; %% FFT length 
sT                               =K/2+1;
overlap                          =1/16;% K*ovlp must be an integer. Nonoverlap length.
 wind                            ='hanning'; 
 wlen                            =K;
 awin                            =hanning(wlen) ; % analysis window is a Hamming window
 navg                            =7;       % Number of consecutive overlapping FFT frames that are used in STFT transformation
 %========================================================================= 
  sourcetype                      ='speech';
   channeltype                  ='RIR';
  recordtype                     ='synthconv';
  Percentage                   =40; %% Percentage of selecter frequency bins (%)
%=================================
  for Case                      =1 %% Case =1, M2N3; Case =2, M3N3; Case =3, M3N4
Case
%==========================================================================  
if     Case                        ==1    
m                                    =2
Nsources                         =3 % Number of sources present
elseif Case                      ==2
m                                     =3
Nsources                         =3 % Number of sources present
elseif Case                      ==3
 m                                    =3
Nsources                         =4 % Number of sources present   
end
  T                                    =nchoosek(8,Nsources);  %%% Number of comination of speech signals
allpermutation                 =randperm(T);
Allpermutation                 =combntns([1:8],Nsources);
%==========================================================================
for jj=2  %% 1 is for female speech data set, 2 is for male speech data set
    if jj==1
speechtype                        ='male';
elseif jj==2
speechtype                        ='female';
    end
%=================================
for kk                                              =1 %:4
  RR                                                 =[0.1,0.15,0.2,0.25];%% RT60=100ms, 150ms, 200ms,250ms
 RT60                                               =RR(kk)
%==========================================================================
for           ii                                        =1%%% The  ii th combination of speech signals,  ii =1:T
Fixpermutation                                =Allpermutation(ii,:);
%==========================================================================
cd build_mixtures
load_data;   
cd ..
%==========================================================================
[xw]                                                   =FFTtransformation(mixture,overlap,K,m,Nsources,navg); %%% STFT transformation
 [Rx]                                                  =Corrf(xw,m,K,navg);%%% Local covariance matrix establishment, size of Rx is M*M*Q*F
[features,eigenvalue]                        =Feature_extraction_PCA(Rx,K); %% Leading eigenvectors extraction
 [est_NoS]                                        =Proposed_clustering_method(Percentage,K,features,Nsources); %% Density-based clustering
 est_NoS
end
end
end
end
 