 function    [est_source_number]                                                  =Proposed_clustering_method(Percentage,F,features,Nsources)
%==========================================================================
[features,gamma ]                                                                         =Fast_density_Clustering(F,features);
[est_source_number]                                                                     =Source_number_detection(Percentage,features,gamma,F,Nsources);
end
%%================Sub Functions============================================
function      [est_sourcenumber]                                                   =Source_number_detection(Percentage,features,gamma,F,Nsources)  
%--------------------------------------------------------------------------
sT                                                     =F/2+1;
 bin_estnumber                                 =zeros(1,sT);
 est_ratio                                            =zeros(1,6);
%==========================================================================
for f                                                     =1:sT
         [K,value,sorte]                           =Gapbasedmethod(gamma{f});   
        bin_estnumber(f)                        =K; 
            K                                             =bin_estnumber(f);
          SORTE{f}                                 =sorte;
%========================================================================== 
   volumn(f)                                   =abs(det(features{f}(:,1:K)*features{f}(:,1:K)'))/K;    
end
%==========================================================================
for ii                                               =Percentage
  maximum                                    =floor(0.01*ii*(F/2+1));  
    [~,loc]                                         =sort(volumn,'descend');
 confidenceloc                               =loc(1:maximum);
 clear maximum
%======================================================================
for i                                          =1:6
     [~,loc]                                   =find(bin_estnumber(confidenceloc)==i);     
     est_ratio(i)                              =size(loc,2);
end
[~,ratioloc]                                   =max(est_ratio);
est_sourcenumber                       =ratioloc;
if ratioloc==Nsources
 threshold(ii)                                 =1;   
elseif ratioloc~=Nsources
 threshold(ii)                                 =0;   
end
  ratioloc                                     =[];
end
%==========================================================================
test                =0;
if test             ==1
 figure;
bar(est_ratio,0.3,'k');
grid on;
axis([1 6 0 max(est_ratio)+4]);
grid on;
xlabel('Total number of clusters', 'Fontsize', 20);
ylabel('Total number of frequency bins', 'Fontsize', 20); 
%==========================================================================   
figure;
plot(est_sourcenumber,'k','LineWidth',3);
xlabel('Percentage of frequency bins (%)','fontsize',16);
ylabel('Estimated source number','fontsize',18);
axis([1 100 0 5]);
grid on;
end
end
%==========================================================================
